// BPP_AutoAspect -    
// BPP_AutoAspect.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "resource.h"
#include <stdio.h>
#include <windows.h>
#include <commctrl.h>
#include "Common.h"
#include "convert_yuy2.h"

#include "BPP_AutoAspect.h"

//     
#define szPluginName	" "

//  ,  		
#define szPluginDesc	" . v1.00"

#define FRAMES_DELAY	5

// ****************   () **************************
HWND			g_hDlg = NULL;
HINSTANCE		g_hInst = NULL;
TCHAR			g_szIniFile[MAX_PATH] = "";
ULONG			g_TypeCPU;
BOOL			g_IsCaptureMode;

//   - YUY2/RGB24
ePixFmt			g_PixFmt;

//   memcpy
MCPY_FUNC *pMcpy;

//  
HANDLE g_hBhWnd=NULL;

//  
HANDLE g_hBhWndRenderer =NULL;	

//   
BYTE delayFrameCount=FRAMES_DELAY;

// 
HDC hdc=NULL, hMemDc=NULL;

//   Bitmap
LPBYTE pBmpData=NULL;

// Handle  Bitmap
HBITMAP hNewBmp;

//     RGB24
int rgb24size;
//     YUY2
int yuy2size;

//  
int width, height;

//  
char chName[65];

//  
char chFreq[20];

//  
char chNum[20];

//  
int line=20;

//  
DWORD lineColor;

////////////////////////////////////////////////////////////////////////////////
// *     *
////////////////////////////////////////////////////////////////////////////////
PROC_PLUGIN Inverse_PL =
{
	szPluginName,				//   (  )
	szPluginDesc,				//  
	PP_Init,					//     (  NULL)
	PP_StartStreaming,			//    StartStreaming (  NULL)
	PP_Processing,				//     ()
	PP_StopStreaming,			//    StopStreaming (  NULL)
	PP_ShowDialog,				//       (  NULL)
	PP_Uninit					//     (  NULL)
};

// ********************* Exports ***********************************************
extern "C" 
{
	__declspec(dllexport) ULONG BeholdTV_Plugin_Version()
	{
		return DSPLUGINVER;		//    
	}

	__declspec(dllexport) PROC_PLUGIN* BeholdTV_Plugin_PR()
	{
		return &Inverse_PL;		//     
	}
} // extern

// ********************* DllMain ************************************************
BOOL APIENTRY DllMain( HINSTANCE hModule, DWORD ul_reason_for_call, LPVOID lpReserved )
{
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			g_hInst = hModule;
			break;
		case DLL_PROCESS_DETACH:
			break;
	}

	return TRUE;
}

//       ,    
void GetIniFileName()
{
	char	szPathFull[MAX_PATH];
	char	szPathIni[MAX_PATH];
	char	szNameDll[MAX_PATH];
	char	szNameIni[MAX_PATH];
	char	*pszFile;

	if (GetModuleFileName(g_hInst, szPathFull, sizeof(szPathFull)))
	{
		if (GetFullPathName(szPathFull, sizeof(szPathIni), szPathIni, &pszFile))
		{
			strcpy(szNameDll, pszFile);

			int	nLen = strlen(szNameDll) - 4;

			strncpy(szNameIni, szNameDll, nLen);
			szNameIni[nLen] = 0;

			strcat(szNameIni, ".ini");
			strcpy(pszFile, szNameIni);

			strcpy(g_szIniFile, szPathIni);
			pszFile = NULL; 
		}
	} // if
} // GetIniFileName

//   
void LoadPluginSettings()
{

	if (g_szIniFile[0] == 0)
		GetIniFileName();
/*
	//       Preview  Capture ( )
	if (g_szIniFile[0] != 0)
	{
		g_MyPreviewSet.MyPar1 = (ULONG) GetPrivateProfileInt("Preview", "MyPar1", DefaultPar1, g_szIniFile);
		g_MyPreviewSet.MyPar2 = (ULONG) GetPrivateProfileInt("Preview", "MyPar2", DefaultPar2, g_szIniFile);
		g_MyPreviewSet.MyPar3 = (ULONG) GetPrivateProfileInt("Preview", "MyPar3", DefaultPar3, g_szIniFile);
		g_MyPreviewSet.MyPar4 = (BOOL)  GetPrivateProfileInt("Preview", "MyPar4", DefaultPar4, g_szIniFile);

		g_MyCaptureSet.MyPar1 = (ULONG) GetPrivateProfileInt("Capture", "MyPar1", DefaultPar1, g_szIniFile);
		g_MyCaptureSet.MyPar2 = (ULONG) GetPrivateProfileInt("Capture", "MyPar2", DefaultPar2, g_szIniFile);
		g_MyCaptureSet.MyPar3 = (ULONG) GetPrivateProfileInt("Capture", "MyPar3", DefaultPar3, g_szIniFile);
		g_MyCaptureSet.MyPar4 = (BOOL)  GetPrivateProfileInt("Capture", "MyPar4", DefaultPar4, g_szIniFile);
	} // if
*/
}

//   
void SavePluginSettings()
{
	if (g_szIniFile[0] == 0)
		GetIniFileName();
/*
	if (g_szIniFile[0] != 0)
	{
		TCHAR szPar[32];

		sprintf(szPar, "%u", g_MyPreviewSet.MyPar1); 
		WritePrivateProfileString("Preview", "MyPar1", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MyPreviewSet.MyPar2); 
		WritePrivateProfileString("Preview", "MyPar2", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MyPreviewSet.MyPar3); 
		WritePrivateProfileString("Preview", "MyPar3", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MyPreviewSet.MyPar4); 
		WritePrivateProfileString("Preview", "MyPar4", szPar, g_szIniFile); 


		sprintf(szPar, "%u", g_MyCaptureSet.MyPar1); 
		WritePrivateProfileString("Capture", "MyPar1", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MyCaptureSet.MyPar2); 
		WritePrivateProfileString("Capture", "MyPar2", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MyCaptureSet.MyPar3); 
		WritePrivateProfileString("Capture", "MyPar3", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MyCaptureSet.MyPar4); 
		WritePrivateProfileString("Capture", "MyPar4", szPar, g_szIniFile); 
	} // if
*/
}

void AppendDialogParams(HWND hwDlg, BOOL IsCapture)
{
	SetDlgItemText(hwDlg, IDC_CH_NUM, chNum);
	SetDlgItemText(hwDlg, IDC_CH_NAME, chName);
	SetDlgItemText(hwDlg, IDC_CH_FREQ, chFreq);
	SetDlgItemInt(hwDlg, IDC_LINE_NUM, line, FALSE);

	char sss[20];
	sprintf ( sss, "%08lXh", lineColor);
	SetDlgItemText(hwDlg, IDC_LINE_COLOR, sss);
}

// Callback     
LRESULT CALLBACK DialogProc(HWND hDlgW, UINT message, WPARAM wParam, LPARAM lParam)
{	
	static BOOL s_IsCaptureMode;
	UDACCEL aAccels[1];

	switch (message)
	{
		case WM_INITDIALOG:			//  
			{
				// ,      
				s_IsCaptureMode = (BOOL) lParam;  

				//   -   0-255
				SendMessage(GetDlgItem( hDlgW, IDC_SPIN_CHNUM ), UDM_SETRANGE, 0, MAKELPARAM(255, 0)); 

				//   -  = 1 
				SendMessage(GetDlgItem( hDlgW, IDC_SPIN_CHNUM ), UDM_GETACCEL, 1, (LPARAM) (LPUDACCEL) aAccels);
				aAccels[0].nInc = 1;
				SendMessage(GetDlgItem( hDlgW, IDC_SPIN_CHNUM ), UDM_SETACCEL, 1, (LPARAM) (LPUDACCEL) aAccels);

				//   -   0-255
				SendMessage(GetDlgItem( hDlgW, IDC_SPIN_TVLINE ), UDM_SETRANGE, 0, MAKELPARAM(255, 0)); 

				//   -  = 1 
				SendMessage(GetDlgItem( hDlgW, IDC_SPIN_TVLINE ), UDM_GETACCEL, 1, (LPARAM) (LPUDACCEL) aAccels);
				aAccels[0].nInc = 1;
				SendMessage(GetDlgItem( hDlgW, IDC_SPIN_TVLINE ), UDM_SETACCEL, 1, (LPARAM) (LPUDACCEL) aAccels);

				//      
				SetWindowText(hDlgW, szPluginName);

				//   
				AppendDialogParams(hDlgW, s_IsCaptureMode);

				// 
				SetTimer(hDlgW,1,100, NULL);

				return TRUE;
			}
			break;
		case WM_DESTROY:			//  
			{
				g_hDlg = NULL;

//				SavePluginSettings();

				return TRUE;
			}
			break;

		case WM_TIMER:				// 
				//   
				AppendDialogParams(hDlgW, s_IsCaptureMode);
			break;

		case WM_COMMAND:			//     

			switch LOWORD(wParam)
			{
				case IDC_LINE_NUM:
					{
						line = GetDlgItemInt(hDlgW, IDC_LINE_NUM, NULL, FALSE);
					} //
					break;

				case ID_EXIT:		//  ""
					{
						DestroyWindow(hDlgW);

						return TRUE;
					}
					break;

				case ID_APPLY:      //  ""                
					{
						return TRUE;
					}
					break;

			default:
					break;

			} // switch
			break;

		default:
			break;
	}
	return FALSE;
}

// ******************   (  API) *********************

////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////
void __cdecl PP_Init(INIT_STR *pPrInit)
{
	//     
/*
	//        
	if (pPrInit)
	{
		g_PtrByOrd = pPrInit->pChByOrd;
		g_PtrByIdx = pPrInit->pChByIdx;
	}
*/
	//    
	LoadPluginSettings();  
}

////////////////////////////////////////////////////////////////////////////////
// *  StartStreaming *
////////////////////////////////////////////////////////////////////////////////
BOOL __cdecl PP_StartStreaming(PARAM_STR *pPrPar)
{
	//      - 
	//   ,  CPU ( ),
	//  ,      (Capture/Preview),
	// ( ,       ..)

	if (pPrPar)
	{
		g_TypeCPU			= pPrPar->TypeCPU;
		g_IsCaptureMode		= pPrPar->IsCapture;
		g_PixFmt			= pPrPar->PixFmt;
	}

	//  
	g_hBhWnd = FindWindow("TVideoFrame", "Video window");
	g_hBhWndRenderer = FindWindowEx((HWND)g_hBhWnd,NULL,"VideoRenderer","ActiveMovie Window");	

	delayFrameCount=5;

	//  
	width = pPrPar->FrameWidth;
	height = pPrPar->FrameHeight;

	//   GDI
	// 
	if ( hdc == NULL )
	{
		hdc = ::GetDC(NULL);
		hMemDc = ::CreateCompatibleDC(hdc);

		// 
		BITMAPINFO bmpHeader;
		::ZeroMemory (&bmpHeader, sizeof(bmpHeader));
		bmpHeader.bmiHeader.biSize = sizeof (BITMAPINFOHEADER);
		bmpHeader.bmiHeader.biWidth = width;
		bmpHeader.bmiHeader.biHeight = -height;
		bmpHeader.bmiHeader.biPlanes = 1;
		bmpHeader.bmiHeader.biBitCount=24;
		bmpHeader.bmiHeader.biCompression = BI_RGB;	// 
		bmpHeader.bmiHeader.biSizeImage=0;	//  BI_RGB

		hNewBmp = ::CreateDIBSection (hMemDc, &bmpHeader, 
			DIB_RGB_COLORS, (LPVOID *)&pBmpData, NULL, 0);

		//    RGB
		rgb24size = width*height*3;
		yuy2size = width*height*2;
	} // if

	return TRUE;
} // PP_StartStreaming

////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////
BOOL __cdecl PP_Processing(PROC_STR *pPr)
{
	//    ,   
	if (pPr->IsHSync==0)
		return TRUE;

	//   
	if ( g_hBhWnd == NULL || g_hBhWndRenderer == NULL)
		return FALSE;		//   ,  

	//   
	if (delayFrameCount!=0)
	{
		delayFrameCount--;
		return TRUE;
	} // if
	else
		delayFrameCount=FRAMES_DELAY;

	//  
	sprintf (chFreq, "%lu", pPr->ChInfo->Frequency);

	//  
	strcpy (chName, pPr->ChInfo->ChnlName);

	//  
	if (pPr->ChInfo->ChnlOrder>=0)
		sprintf ( chNum, "%d", pPr->ChInfo->ChnlOrder+1);
	else
		strcpy (chNum, "---");

	//      
	if (pPr->SrcBuff[0] == NULL)
		return FALSE;

	//    memcpy
	pMcpy = pPr->pMcpy;

	//    RGB24
	if ( g_PixFmt == fYUY2 )
	{ // YUY2->RGB24
		ConvertYUY2_RGB24 (pPr->SrcBuff[0], pBmpData, width, height, true);
	} // if
	else
	{ //    RGB24
		(*pMcpy) (pBmpData, pPr->SrcBuff[0], rgb24size);
	} // else

//	WriteText ( (LPBYTE) pPr->SrcBuff[0], width, height, 
//		" ,   !" ); 

/*
     YUY2 - http://www.fourcc.org/yuv.php#YUY2
    - http://avisynth.org.ru/docs/russian/advancedtopics/sampling.htm
   - YUNV, V422, YUYV.    4:2:2. 
 YUY2 ( YUYV)   4:2:2.
  4:2:2 ,       (luminance (Y)),
     U  V,   (bandwidth)  
   .
  4:2:2       PAL/SECAM.
      U  V , .  
   2 ,    PAL  NTSC (   )...

 ,   ,    () UV ()
   . 
  :
 Y - 
 U -   
 V -   
   , 4   2    .
  , ..     .
 :
   
   0           Y0
   1           U0
   2           Y1
   3           V0
   4-   2 :
  1- (Y0,U0,V0)
  2- (Y1,U0,V0)
*/
	/////////////////////////////////////////////////////////////////////
    //  YUY2
	/////////////////////////////////////////////////////////////////////

	/////////////////////////////////////////////////////////////////////
	//   
	/////////////////////////////////////////////////////////////////////
	int upperCutLine=0;

	//   (  YUY2)
	LPBYTE pData = pPr->SrcBuff[0];

	//    
	DWORD dwAverageY=0;
	BYTE averageY=0;

	//     (  )
	for (int row = 0; row< height/2; row ++)
	{
		//     ( -   YUY2)
		for(int col=0;col<width/2;col++)
		{
			//    Y0  Y1
			BYTE y0 = *pData;
			BYTE y1 = *(pData+2);

			//      
			pData+=4;

			// 
			dwAverageY += y0;
			dwAverageY += y1;
		} // for

		//   
		// dwAverageY = dwAverageY / (width/2) = 2*dwAverageY/width;
		dwAverageY = 2*dwAverageY/width;
		averageY=(BYTE)dwAverageY;

		//      ,  
		if (averageY<50)
			upperCutLine++;
	} // for

	//  
	DrawLine (width, upperCutLine);

/*
	// 
	char text[50];
	sprintf ( text, ". Y=%d; line=%d", averageY, upperCutLine);
	WriteText (width, height, text);
*/
/*
	/////////////////////////////////////////////////////////////////////
    //  RGB24
	/////////////////////////////////////////////////////////////////////

	/////////////////////////////////////////////////////////////////////
	//   
	/////////////////////////////////////////////////////////////////////
	int upperCutLine=0;

	//    
	LPBYTE pBmp = pBmpData;

	int r, g, b;

	//     (  )
	for (int row = 0; row< height/2; row ++)
	{
		r=0;
		g=0;
		b=0;

		//    
		for(int col=0;col<width;col++)
		{
			//    bmp1
			// with blue stored at the lowest address, green next then red
			// B, R, G
			__int32 pixel = *((__int32 *)pBmp);

			pixel&=0x00FFFFFF;	//   3 ,  RGB24

			LPBYTE p = (LPBYTE)&pixel;
			b+=*p; p++;
			r+=*p; p++;
			g+=*p;

			//  
			pBmp+=3;
		} // for

		//   
		r/=width;
		g/=width;
		b/=width;

		//    ,  
//		if (r<50 && g<50 && b<50)
		if (r<15 && g<15 && b<15)
			upperCutLine++;
	} // for

	//  
	DrawLine (width, upperCutLine);
	/////////////////////////////////////////////////////////////////////
	//    
	/////////////////////////////////////////////////////////////////////
*/
/*
	/////////////////////////////////////////////////////////////////////
	//   
	/////////////////////////////////////////////////////////////////////
	int lowerCutLine=height-1;

	//    
//	pBmp = pRgb24Data;
	pBmp = pBmpData;

	//      (  )
	for (int row = height-1; row>height/2; row --)
	{
		r=0;
		g=0;
		b=0;

		//    
		for(int col=0;col<width;col++)
		{
			//    bmp1
			// with blue stored at the lowest address, green next then red
			// B, R, G
			__int32 pixel = *((__int32 *)pBmp);

			pixel&=0x00FFFFFF;	//   3 ,  RGB24

			LPBYTE p = (LPBYTE)&pixel;
			b+=*p; p++;
			r+=*p; p++;
			g+=*p;

			//  
			pBmp+=3;
		} // for

		//   
		r/=width;
		g/=width;
		b/=width;

		//    ,  
		if (r<50 && g<50 && b<50)
			lowerCutLine--;
	} // for

	//  
	DrawLine (width, lowerCutLine);
	/////////////////////////////////////////////////////////////////////
	//    
	/////////////////////////////////////////////////////////////////////
*/

/*
	// 
	char text[50];
	sprintf ( text, " RGB=(%d,%d,%d); line=%d", r, g, b, upperCutLine);
	WriteText (width, height, text);
*/
//	DrawLine (width, line);

	//   YUY2
	if ( g_PixFmt == fYUY2 )
	{ // YUY2->RGB24
		ConvertYUY2_RGB24 (pBmpData, pPr->SrcBuff[0], width, height, false);
	} // if
	else
	{ //    RGB24
		(*pMcpy) ( pPr->SrcBuff[0], pBmpData, rgb24size);
	} // else

	return TRUE;
} // PP_Processing

////////////////////////////////////////////////////////////////////////////////
// *  StopStreaming *
////////////////////////////////////////////////////////////////////////////////
void __cdecl PP_StopStreaming(void)
{
	//     
	// (      ..)

	//  
	g_hBhWnd = g_hBhWndRenderer = NULL;	

	if (hdc!=NULL)
	{
		DeleteObject(hNewBmp);
		DeleteObject(hMemDc);
		DeleteObject(hdc);
		GdiFlush ();

		hdc = NULL;
	} // if

	//    RGB24;
//	delete pRgb24Data;
} // PP_StopStreaming

////////////////////////////////////////////////////////////////////////////////
// *     *
////////////////////////////////////////////////////////////////////////////////
void __cdecl PP_ShowDialog(DLG_STR *pDlgPar)
{
	if(g_hDlg == NULL)
	{
		if (g_szIniFile[0] == 0)
			LoadPluginSettings();

		// pDlgPar->LangCode   ,      

		g_hDlg = CreateDialogParam(g_hInst, (LPCTSTR) IDD_MYDIALOG, pDlgPar->hwndParent,
			(DLGPROC) DialogProc, (LPARAM) pDlgPar->IsCapture);
		if (g_hDlg)
		{
			//      
			RECT pRect, lRect;			

			GetWindowRect(pDlgPar->hwndParent, &pRect);
			GetWindowRect(g_hDlg, &lRect);

			int lft, top;

			lft = pRect.left + (pRect.right / 2 - lRect.right / 2);		
			top = pRect.top + (pRect.bottom / 2 - lRect.bottom / 2);

			SetWindowPos(g_hDlg, HWND_TOP, lft, top, 0, 0, SWP_NOACTIVATE | SWP_NOSIZE);
			ShowWindow(g_hDlg, SW_SHOW);
		} // if
    } // if
} // PP_ShowDialog

////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////
void __cdecl PP_Uninit(void)
{
	//     
	SavePluginSettings();		//    

	if(g_hDlg != NULL)
	{
		DestroyWindow(g_hDlg);  //  
		g_hDlg = NULL;
	}
} // PP_Uninit

//    
void DrawLine (int width, int linePos)
{
	// http://radiofront.narod.ru/htm/prog/htm/winda/api/paint.html#4
	SelectObject(hMemDc, hNewBmp);

	//   
	HPEN hPen = CreatePen (PS_SOLID, 1,RGB(255,255,255));
	SelectObject(hMemDc, hPen);

	Line ( hMemDc, 0, linePos, width-1, linePos );

	//  
    DeleteObject(hPen);
} // DrawLine

//    
BOOL Line(HDC hdc, int x1, int y1, int x2, int y2)
{
	MoveToEx(hdc, x1, y1, NULL); //   x1, y1
	return LineTo(hdc, x2, y2);
} // Line 

//    
void WriteText (int width, int height, LPCTSTR pString)
{
	SelectObject(hMemDc, hNewBmp);

	//  
	SetTextColor(hMemDc, RGB ( 0, 255, 0 ));

	//  
	SetBkMode(hMemDc, TRANSPARENT);

	// 
	// Arial Cyr, 24
	long lfHeight = -MulDiv(24, GetDeviceCaps(hdc, LOGPIXELSY), 72);
	HFONT hFont = CreateFont(lfHeight, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, "Arial Cyr");

    SelectObject(hMemDc, hFont);

	RECT r;
	SetRect(&r, 1,1,width,height);
    DrawText(hMemDc, pString, -1, &r, DT_CENTER|DT_VCENTER|DT_SINGLELINE ); 
    DeleteObject(hFont);

	//  
	////////////////////////////////////////////////////////////////////////////
} // WriteText

//  YUY2<->RGB32 
void ConvertYUY2_RGB24 (LPBYTE pSrcFrame, LPBYTE pDst, int width, int height, BOOL isToRgb)
{
	//  
	int Mode = isToRgb?MODE_mmx_ConvertYUY2toRGB24:MODE_mmx_ConvertRGB24toYUY2;
	int srcStride, dstStride;
	
	int iMatrix = 0; // 0..3 //0=rec601, 1=rec709, 3=PC_601, 7=PC_709

	switch(Mode)
	{
		case MODE_mmx_ConvertRGB24toYUY2:	// RGB24->YUY2
			{
				srcStride = width * 3;
				dstStride = width * 2;

				// 
				Tmmx_ConvertRGBtoYUY2<true, false>::mmx_ConvertRGBtoYUY2(pSrcFrame, pDst,
					srcStride, dstStride, width, height, iMatrix);
			}
		break;

		case MODE_mmx_ConvertYUY2toRGB24:	// YUY2->RGB24
			{
				srcStride = width * 2;
				dstStride = width * 3;

				// 
				Tmmx_ConvertYUY2toRGB<false, false>::mmx_ConvertYUY2toRGB(pSrcFrame, pDst,
					pSrcFrame + (height * srcStride), srcStride, dstStride, width * 2, iMatrix);
			}
		break;	
	} // switch
} // ConvertYUY2_RGB24
